const {app} = require('electron').remote;
const path = require('path');
const fs = require('fs');
const {dialog} = require('electron').remote;
const langSave = require('electron-json-storage');
var shell = require('electron').shell;


//open links externally by default
$(document).on('click', 'a[href^="http"]', function(event) {
    event.preventDefault();
    shell.openExternal(this.href);
});
/*
$(document).on('click', '#ppDonation[action^="https"]', function(event) {
    event.preventDefault();
    shell.openExternal(this.action);
});
*/
window.onload = function() {
    // Populate the table
    loadLanguage();
}
/*********** Sprache laden ************/
function loadLanguage(){
    langSave.has('language', function(error, hasKey) {
        if (error) throw error;
        if (hasKey) {
            langSave.get('language', function(error, data) {
                if (error) throw error;
                var language=data.lang;
                var languageInput = $(document).find('#aside #infoWindow .inside .language input');
                if(language === "en") {
                    languageInput.eq(0).prop("checked",true);
                    languageInput.eq(1).prop("checked",false);
                }else{
                    languageInput.eq(0).prop("checked",false);
                    languageInput.eq(1).prop("checked",true);
                }
            });
        }
    });
}
/*********** Sprache speichern ************/
$(document).on('click','#aside #infoWindow .inside .language input',function(){
    var languageInput = $(document).find('#aside #infoWindow .inside .language input[type=radio]:checked').val() || "de";
    langSave.set('language', { lang: languageInput }, function(error) { if (error) throw error; });
});

/*********** export ************/
$(document).on('click','#outputData .data.export button',function(){
    exportData();
});

function exportData(){
    //
    var format = $(document).find('#outputData .data .output.format span').text();
    var width = $(document).find('#outputData .data .output.breite span').text();
    var height = $(document).find('#outputData .data .output.hoehe span').text();
    //
    var marginTop = $(document).find('#outputData .data .output.randOben span').text();
    var marginBottom = $(document).find('#outputData .data .output.randUnten span').text();
    var marginRight = $(document).find('#outputData .data .output.randInnen span').text();
    var marginLeft = $(document).find('#outputData .data .output.randAussen span').text();
    //
    var cloumnCount = $(document).find('#outputData .data .output.columnCount span').text();
    var cloumnSpace = $(document).find('#outputData .data .output.columnSpace span').text();
    var cloumnWidth = $(document).find('#outputData .data .output.columnWidth span').text();
    //
    var fontSize = $(document).find('#outputData .data .output.grid.fontSize span').text();
    var gridStart = $(document).find('#outputData .data .output.grid.gridStart span').text();
    var lineHeight = $(document).find('#outputData .data .output.grid.durchschuss span').text();
    //
    var typoGridInput = $(document).find('#outputData .data #typoGridOutPut').text();
    //
    var exportData = langErgebnis+"\n\n";
    exportData += langFormat+"\n";
    exportData += langFormat+":\t\t"+format+"\n";
    exportData += langFormatWidth+":\t\t"+width+" mm\n";
    exportData += langFormatHeight+":\t\t"+height+" mm\n\n";
    exportData += langSpalten+"\n";    
    exportData += langSpaltenAnzahl+":\t\t"+cloumnCount+"\n";
    exportData += langSpaltenabstand+":\t"+cloumnSpace+" mm\n";
    exportData += langSpaltenBreite+":\t\t"+cloumnWidth+" mm\n\n";    
    exportData += langRand+"\n";
    exportData += langRandOben+":\t\t"+marginTop+" mm\n";
    exportData += langRandUnten+":\t\t"+marginBottom+" mm\n";
    exportData += langRandInnen+":\t\t"+marginRight+" mm\n";
    exportData += langRandAussen+":\t\t"+marginLeft+" mm\n\n";
    exportData += langRaster+"\n";     
    exportData += langSchriftgroesse+":\t"+fontSize+" Pkt.\n";
    exportData += langRasterStart+":\t"+gridStart+" mm\n";
    exportData += langZeilenAbstand+":\t"+lineHeight+" mm\n\n";
    exportData += langTypoGrid+"\n";
    exportData += typoGridInput+"\n";
    //
    dialog.showSaveDialog({ filters:[
            {
                name:'Text-Export',
                extensions: ["txt"]
            }
        ]}, function (fileName) {
            if(fileName === undefined) {
                alert(langNotSaved);
                return;
            }
            fs.writeFile(fileName,exportData,'utf-8', (err) => {
                if(err) {
                    alert(langSavedError+"\n"+err.message);
                    return;
                }else{                
                    alert(langSavedInfo);
                }
            });
        });    
}