const {app, BrowserWindow,Menu} = require('electron');
const path = require('path');
const url = require('url');
const langSave = require('electron-json-storage');

let win
function createWindow () {
    // Erstellen des Browser-Fensters.
    win = new BrowserWindow({width: 1550, height: 725, title:"typoMan",titleBarStyle:'customButtonsOnHover', resizable:false, frame:false,textAreasAreResizable:false,autoHideMenuBar:true,scrollBounce:true,backgroundColor: '#f8f8f8'})
    win.setMenu(null);

    // und Laden der index.html der App.
    win.loadFile('index.html')

    // Öffnen der DevTools.
    //win.webContents.openDevTools()

    /*  
    // Ausgegeben, wenn das Fenster geschlossen wird.
    */
    win.on('close', function(e){
       win = null
    });      
}
//app.on('ready', createWindow)
app.on('ready', basicSettings)
//
app.on('window-all-closed', () => {
    if (process.platform !== 'darwin') {
        app.quit()
    }
})
app.on('activate', () => {
    if (win === null) {
        createWindow()
    }
})

//Sprache
function basicSettings(){     
    /***************** Sprachen ******************/    
    // Sprache zusätzlich in Json File speichern
    langSave.has('language', function(error, hasKey) {
        if (error) throw error;
        if (hasKey) {
            langSave.get('language', function(error, data) {
                if (error) throw error;
                global.language=data.lang;
                createWindow();                
            });
        }else{
            global.language="de";
            langSave.set('language', { lang: language }, function(error) { if (error) throw error; });            
            createWindow();
        }
    });
        /***************** copy&paste ******************/
    // Create the Application's main menu
    var template = [{
        label: "Application",
        submenu: [
            { label: "Quit", accelerator: "Command+Q", click: function() { app.quit(); }}
        ]}, {
        label: "Edit/Bearbeiten",
        submenu: [
            { label: "Undo/Rückgängig", accelerator: "CmdOrCtrl+Z", selector: "undo:" },
            { label: "Redo/Wiederholen", accelerator: "Shift+CmdOrCtrl+Z", selector: "redo:" },
            { type: "separator" },
            { label: "Cut/Ausschneiden", accelerator: "CmdOrCtrl+X", selector: "cut:" },
            { label: "Copy/Kopieren", accelerator: "CmdOrCtrl+C", selector: "copy:" },
            { label: "Paste/Einfügen", accelerator: "CmdOrCtrl+V", selector: "paste:" },
            { label: "Select all/Alles auswählen", accelerator: "CmdOrCtrl+A", selector: "selectAll:" }
        ]}
    ];
    Menu.setApplicationMenu(Menu.buildFromTemplate(template));     
}

process.env['ELECTRON_DISABLE_SECURITY_WARNINGS'] = 'true'